/* Pelda 04/01 */

/**
 * Egy egyszeru ember osztaly mezokkel es metodusokkal.
 * <p>
 * Nevezektan: az osztalyok neve nagybetuvel kezdodik, minden tovabbi szo elso
 * betuje nagy. A mezok es metodusok neve kisbetuvel kezdodik es minden tovabbi
 * szo kezdobetuje nagy. A final static mezok neve csupa nagybetu, szohataron
 * alahuzasjellel elvalasztva.
 *
 * @author Kalman Miklos
 * @author AKos Kiss
 */
public class Ember {

  /** Konstans a ferfi nem jelolesere. */
  public static final boolean FERFI = true;
  /** Konstans a noi nem jelolesere. */
  public static final boolean NO = false;

  /** Az ember neve. */
  private String nev;
  /** Az ember szuletesi datuma. */
  private int szulDatum;
  /** Az ember neme. */
  private boolean ferfi; // elnevezs: isMan

  // elnevezs: setName - setter
  public void nevBeallit(String ujNev) {
    nev = ujNev;
  }

  // elnevezs: getName - getter
  public String neve() {
    return nev;
  }

  // elnevezs: setBirthday - setter
  public void szulDatumBeallit(int ujSzulDatum) {
    szulDatum = ujSzulDatum;
  }

  // elnevezs: getBirthday - getter
  public int szulDatumLeker() {
    return szulDatum;
  }

  // elnevezs: setSex(boolean isMan) - setter
  public void nemBeallit(boolean ujFerfiE) {
    ferfi = ujFerfiE;
  }

  // elnevezs: getSex - getter
  public boolean neme() {
    return ferfi;
  }

  /**
   * Ez egy statikus fuggveny, nem kell objektumpeldany a hivasahoz.
   */
  public static void kiIrEmber(String nev, int szulDatum, boolean ferfie) {
    System.out.println("Az ember neve "+nev+" aki mellesleg "+(ferfie?("Ferfi"):("No"))+" es "+szulDatum+" a szuletesi datuma");
  }

  // elnevezs: ~ string toString()
  public void info() {
    System.out.println("Az ember neve "+this.nev+
                       " aki mellesleg "+(this.ferfi?("Ferfi"):("No"))+
                       " es "+this.szulDatum+" a szuletesi datuma");
  }

  /**
   * Ez a default konstruktor. A mezoket alapertekekkel inicializalja.
   */
  public Ember() {
    nev="Nincs"; // Az objektum mezoi elerhetoek a nevukkel.
    szulDatum = 1900;
    ferfi = FERFI;
  }

  /**
   * Ez egy konstruktor tobb parameterrel.
   */
  public Ember(String neve, int szuletett, boolean neme) {
    this.nev = neve; // A this valtozo mindig az aktualis objektumra hivatkozik.
    this.szulDatum = szuletett;
    this.ferfi = neme;
  }


  public static void main(String[] args) {
    // Ember objektum letrehozasa es inicializalasa a default konstruktor
    // segitsegevel. A letrejott objektum referenciajanak tarolasa az ember01
    // valtozoban.
    Ember ember01 = new Ember();
    // Az ember01 valtozoban hivatkozott objektumon az info metodus meghivasa.
    ember01.info();

    // Ugyanez nem default konstruktorral es az ember02 valtozoval.
    Ember ember02 = new Ember("Nagy Melinda",1983,Ember.NO);
    ember02.info();

    // Az ember02 valtozoban tarolt referencia masolasa az ember03 valtozoba.
    Ember ember03 = ember02;
    // Az ember03 valtozoban hivatkozott objektumon a szulBeallit metodus
    // meghivasa.
    ember03.szulDatumBeallit(1982);
    // A szulBeallit metodus meghivasa az ember02 es ember03 valtozokban
    // hivatkozott objektumokon.
    ember02.info();
    ember03.info();

    // A referenciak elengedese. A szemetgyujto felszabadithatja a mar nem
    // hivatkozott objektumokat.
    ember01 = null;
    ember02 = null;
    ember03 = null;

    // Static fuggveny hivasa objektumpeldany nelkul.
    Ember.kiIrEmber("Varga Bela",1979,Ember.FERFI);
  }


}
