/* Pelda 05/01 */

/**
 * Egy egyszeru ember osztaly privat mezokkel es publikus metodusokkal.
 *
 * @author Kalman Miklos
 * @author AKos Kiss
 */
public class PrivatEmber {

  /** Konstans a ferfi nem jelolesere. */
  public static final boolean FERFI = true;
  /** Konstans a noi nem jelolesere. */
  public static final boolean NO = false;

  /** Az ember neve. */
  private String nev;
  /** Az ember szuletesi datuma. */
  private int szulDatum;
  /** Az ember neme. */
  private boolean ferfi; // elnevezs: isMan

  // elnevezs: setName - setter
  public void nevBeallit(String ujNev) {
    nev = ujNev;
  }

  // elnevezs: getName - getter
  public String neve() {
    return nev;
  }

  // elnevezs: setBirthday - setter
  public void szulDatumBeallit(int ujSzulDatum) {
    szulDatum = ujSzulDatum;
  }

  // elnevezs: getBirthday - getter
  public int szulDatumLeker() {
    return szulDatum;
  }

  // elnevezs: setSex(boolean isMan) - setter
  public void nemBeallit(boolean ujFerfiE) {
    ferfi = ujFerfiE;
  }

  // elnevezs: getSex - getter
  public boolean neme() {
    return ferfi;
  }

  /**
   * Ez egy statikus fuggveny, nem kell objektumpeldany a hivasahoz.
   */
  public static void kiIrEmber(String nev, int szulDatum, boolean ferfie) {
    System.out.println("Az ember neve "+nev+" aki mellesleg "+(ferfie?("Ferfi"):("No"))+" es "+szulDatum+" a szuletesi datuma");
  }

  // elnevezs: ~ string toString()
  public void info() {
    System.out.println("Az ember neve "+this.nev+
                       " aki mellesleg "+(this.ferfi?("Ferfi"):("No"))+
                       " es "+this.szulDatum+" a szuletesi datuma");
  }

  /**
   * Ez a default konstruktor. A mezoket alapertekekkel inicializalja.
   */
  public PrivatEmber() {
    nev="Nincs"; // Az objektum mezoi elerhetoek a nevukkel.
    szulDatum = 1900;
    ferfi = FERFI;
  }

  /**
   * Ez egy konstruktor tobb parameterrel.
   */
  public PrivatEmber(String neve, int szuletett, boolean neme) {
    this.nev = neve; // A this valtozo mindig az aktualis objektumra hivatkozik.
    this.szulDatum = szuletett;
    this.ferfi = neme;
  }

}
