/* Pelda 08/01 */

/**
 * Nehany pelda a hibakezelesre.
 *
 * @author Endre Horvath
 * @author Akos Kiss
 */
public class Hiba {
  // felveszunk nehany mezot a hibak letrehozasara
  int szamlalo;
  int nevezo;
  int[] tomb;

  // figyelem ez a konstruktor a tomb-ot null-ra allitja
  public Hiba() {
    szamlalo=0;
    nevezo=1;
    tomb=null;
  }

  public Hiba(int a, int b, int c) {
    szamlalo=a;
    nevezo=b;
    tomb=new int[c];
  }

  // ez a metodus a tomb hosszat adja vissza es ha a tomb null,
  // akkor egy NullPointerException hibat dob
  public int tombHossz() throws NullPointerException {
    return tomb.length;
  }

  // ez a metodus a szamlalo/nevezo egeszosztas erteket adja vissza
  // ha a nevezo 0, akkor egy ArithmeticException-t dob
  public int osztas() throws ArithmeticException {
    return (szamlalo/nevezo);
  }

  // ez a metodus egyszeruen dobja a sajat hibankat
  public void sajatHiba() throws SajatKivetel {
    System.out.println("Dobjuk a sajat hibankat!");
    throw new SajatKivetel();
  }

  public static void main (String[] args) {
    // az argumentumok szamanak fuggvenyeben a megfelelo konstruktort hivjuk
    Hiba h1;
    if (args.length==3) {
      // itt is keletkezhet hiba (NumberFormatException), de mivel a
      // RuntimeException leszarmazottja, nem kotelezo deklaralni sem es
      // elkapni sem
      // egyebkent az ArithmeticExeption es a NullPointerException is ilyen
      int a=Integer.parseInt(args[0]);
      int b=Integer.parseInt(args[1]);
      int c=Integer.parseInt(args[2]);
      h1=new Hiba(a,b,c);
    } else {
      h1=new Hiba();
    }

    //megprobaljuk meghivni a fuggvenyeket es elkapni a hibakat
    try {
      System.out.println("a h1.tomb hossza = "+h1.tombHossz());
      System.out.println("a h1.szamlalo/h1.nevezo osztas eredmenye = "+h1.osztas());
      h1.sajatHiba();
    } catch (NullPointerException e) {
      System.out.println("Most egy NullPointerException-t fogtunk");
    } catch (ArithmeticException e) {
      System.out.println("Most egy ArithmeticException-t fogtunk");
    } catch (SajatKivetel e) {
      System.out.println("Elkaptuk a sajat hibankat!");
    }
  }
}
